--[[
Copyright 2008, 2009 João Cardoso
Sushi is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Sushi.

Sushi is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Sushi is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushi. If not, see <http://www.gnu.org/licenses/>.
--]]

local Sushi = LibStub('Sushi-2.0')
local Button = Sushi:NewWidgetClass('ListButton', {
	frameType = 'Button',
	template = 'OptionsListButtonTemplate',
	insets = {top = 1, left = 5},
	version = 1,
})

if not Button then
	return
end


--[[ Events ]]--

function Button:OnCreate()
	self:SetScript('OnClick', self.OnClick)
	self:SetNormalFontObject('GameFontHighlight')
	self.highlight:SetPoint('TOPLEFT', 0, -1)
	self.highlight:SetAlpha(0)
	self:SetHeight(19)
end

function Button:OnRelease()
	self:SetSelected(nil)
	self:SetText(nil)
end

function Button:OnClick()
	PlaySound('igMainMenuOptionCheckBoxOn')
	self:FireCallback('OnClick')
end


--[[ Selected ]]--

function Button:SetSelected(selected)
	if selected then
		self.highlight:SetAlpha(1)
		self:LockHighlight()
	else
		self.highlight:SetAlpha(0)
		self:UnlockHighlight()
	end
end

function Button:IsSelected()
	return self.highlight:GetAlpha() == 1
end


--[[ Embedding ]]--

Button:UpdateEmbeds()